#!/usr/local/bin/ruby

require "AnimX"

FONTNAME1 = "-*-helvetica-bold-r-normal-*-20-*-*-*-*-*-*-*"
N = 15
down = 0; g = 6; h = 60
save = []; x = []; y = []; vx = []; vy = []; ix = []; iy = []

for i in 0..N-1
  x[i] = 0; y[i] = 0; vx[i] = 0; vy[i] = 0; ix[i] = 0; iy[i] = 0
end

g = ARGV[1].to_f if ARGV.size > 1
h = g * 10
h = ARGV[2].to_f if ARGV.size > 2

w1 = AnimX::Win.new(0, 0, 400, 400); w1.SetWindowTitle("Gravity Apple")
w1.LockCurrentSize

#apple = AnimX.LoadPPM("ppm/apple.ppm", 1)
#star = AnimX.LoadPPM("ppm/star.ppm", 1)
apple = AnimX::PPM.new("ppm/apple.ppm", 1)
star = AnimX::PPM.new("ppm/star.ppm", 1)
AnimX.SetFont(FONTNAME1)
AnimX.SetDrawMode(AnimX::Delay)

AnimX.SetColor(AnimX.GetColor("black"))
w1.FillRect(0, 0, 400, 400)
for i in 0..30-1
  w1.DrawPPM(star, rand(2**31) % 390, rand(2**31) % 390)
end

for i in 0..N-1
  ix[i] = rand(2**31) % 370; x[i] = ix[i]; vx[i] = 0
  iy[i] = rand(2**31) % 370; y[i] = iy[i]; vy[i] = 0
  save[i] = AnimX.MakeEmptyPPM(apple.h, apple.v)
end

for t in 0..500-1
  if t > 400
	AnimX.SetColor(t % 20); down = 2
	w1.DrawString(160, 200, "and DOWN!!")
  elsif t >300
	AnimX.SetColor(t % 20); down = -1
	w1.DrawString(110, 200, "UP!!")
  end
  for j in 0..N-1
	w1.GetArea(save[j], ix[j], iy[j], apple.h, apple.v)
  end
  for j in 0..N-1
	w1.DrawPPM(apple, ix[j], iy[j])
  end
  w1.RedrawWindow
  AnimX.Flush
  for j in 0..N-1
	ax = 0; ay = 0
	w1.DrawPPM(save[j], ix[j], iy[j])
	for i in 0..N-1
	  if (d = (x[i] - x[j]) ** 2 + (y[i] - y[j]) ** 2) != 0
		if d >870
		  ax += (x[i] - x[j]) / d * g
		  ay += (y[i] - y[j]) / d * g
		else
		  ax += -(x[i] - x[j]) / d * h
		  ay += -(y[i] - y[j]) / d * h
		end
	  end
	end
	vx[j] += ax; vy[j] += ay + down
	x[j] += vx[j]; y[j] += vy[j]
	ix[j] = x[j]; iy[j] = y[j]
	if ix[j] < 0
	  x[j] = 0
	  vx[j] *= -0.5
	elsif ix[j] > 370
	  x[j] = 370
	  vx[j] *= -0.5
	end
	if iy[j] < 0
	  y[j] = 0
	  vy[j] *= -0.5
	elsif iy[j] > 370
	  y[j] = 370
	  vy[j] *= -0.5
	end
  end
#  sleep(0.0001)
end


AnimX.Flush
gets
